﻿using InABox.Wpf;
using InABox.Core;
using System.Windows;
using FastReport.DevComponents.DotNetBar;

namespace InABox.DynamicGrid
{
    /// <summary>
    /// Interaction logic for FilterEditorWindow.xaml
    /// </summary>
    public partial class FilterEditorWindow : ThemableWindow
    {
        private BaseFilterNode? FilterNode;

        public FilterEditorWindow()
        {
            InitializeComponent();
        }

        public void SetFilter<T>(Filter<T> filter)
        {
            FilterNode = new FilterNode<T>(filter);
            FilterNode.Margin = new Thickness(5);

            Content.Content = FilterNode;

            Title = $"Edit {typeof(T).Name} Filter";
        }
        public Filter<T>? GetFilter<T>()
        {
            return (FilterNode as FilterNode<T>)?.GetFilter();
        }

        private void Cancel_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = false;
        }

        private void OK_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = true;
            Close();
        }
    }
}
